---
title: Setting a voice filter
---
import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';

# Setting a voice filter

To change your voice, you have to send one single message: `loadVoice` 

This message specifies the voice ID, and as long as the ID exists, almost immediately the voice will be affected.

The format of the message is the following:

```json
{
  "action": "loadVoice",
  "id": "ff7d7f15-0cbf-4c44-bc31-b56e0a6c9fa6",
  "payload": {
    "voiceID": "[the voice ID to be used]"
  }
}
```

The following code shows how you can implement it using JavaScript.

<Tabs>
<TabItem value="javascript" label="JavaScript">

```javascript
const socket = new WebSocket('ws://localhost:59129/v1');

socket.addEventListener('open', (event) => {
  const message = {
    action: "loadVoice",
    id: "ff7d7f15-0cbf-4c44-bc31-b56e0a6c9fa6",
    payload: {
      voiceID: "robot"
    }
  };

  socket.send(JSON.stringify(message));
});

```
</TabItem>
<TabItem value="py" label="Python">

```python
import websocket
import json

def on_open(ws):
    message = {
        "action": "loadVoice",
        "id": "ff7d7f15-0cbf-4c44-bc31-b56e0a6c9fa6",
        "payload": {
            "voiceID": "robot"
        }
    }
    ws.send(json.dumps(message))

websocket.enableTrace(True)
ws = websocket.WebSocketApp("ws://localhost:59129/v1",
                            on_open=on_open)
ws.run_forever()

```
</TabItem>
<TabItem value="java" label="Java">

```java
import javax.websocket.ClientEndpoint;
import javax.websocket.OnMessage;
import javax.websocket.OnOpen;
import javax.websocket.Session;
import javax.websocket.ContainerProvider;
import javax.websocket.WebSocketContainer;

import org.json.JSONObject;

@ClientEndpoint
public class MyClientEndpoint {
    @OnOpen
    public void onOpen(Session session) {
        JSONObject message = new JSONObject();
        message.put("action", "loadVoice");
        message.put("id", "ff7d7f15-0cbf-4c44-bc31-b56e0a6c9fa6");
        JSONObject payload = new JSONObject();
        payload.put("voiceID", "robot");
        message.put("payload", payload);
        session.getAsyncRemote().sendText(message.toString());
    }

    @OnMessage
    public void onMessage(String message) {
        System.out.println("Received message: " + message);
    }

    public static void main(String[] args) throws Exception {
        WebSocketContainer container = ContainerProvider.getWebSocketContainer();
        Session session = container.connectToServer(MyClientEndpoint.class, 
                                                    null, 
                                                    new java.net.URI("ws://localhost:59129/v1"));
        Thread.sleep(Long.MAX_VALUE);
    }
}

```
</TabItem>
</Tabs>

Once the voice filter has been changed, the API will issue an event to **all connected clients**, which you can use to track which voice has been loaded.

The event issued by the API is `voiceChangedEvent` and it contains the actual ID of the filtered selected.

The format of that message looks like this:

```json
{
  "actionType": "voiceChangedEvent",
  "appVersion": "2.0.0.34",
  "actionId": "9aabf036-0ba4-4359-a2d6-90ac8691e320",
  "actionObject": {
    "voiceID": "[the id of the voice that was loaded last]"
  }
}
```

:::tip
Keeping track of this event is useful if you’re building one of many clients that can affect the same instance of Voicemod.
:::